:: http://querdenker.at
:: Built on setx
@echo off
:start
cls
echo This script allows you to set environment variables.
echo Please keep in mind that variables are defined with "name=value"
echo You will be asked for the name of the variable first, then for the value.
echo.
echo Which kind of variable would you like to set?
echo.
echo ===Current User===
echo.
echo 1. User Variable
echo 2. User Path Variable
echo.
echo ===Global System=== (needs elevated user permissions. Execute script as administrator!)
echo.
echo 3. System Variable
echo 4. System Path Variable
echo.
echo ===Show content of Path variables===
echo.
echo 5. Show User Path Variable
echo 6. Show System Path Variable
echo.
echo --------
echo 7. Exit

CHOICE /C 1234567 /N
IF ERRORLEVEL 7 exit
IF ERRORLEVEL 6 goto show_sys_path_var
IF ERRORLEVEL 5 goto show_user_path_var
IF ERRORLEVEL 4 goto sys_path_var
IF ERRORLEVEL 3 goto sys_var
IF ERRORLEVEL 2 goto user_path_var
IF ERRORLEVEL 1 goto user_var

:user_var
cls
set uv_name=
set uv_val=
echo =========================================================================================
echo  Please Enter the name of the user variable:
echo.
set /p uv_name=. 
if [%uv_name%] == [] goto user_name_empty
cls
:user_var_val
cls
echo =========================================================================================
echo  Now enter the value of user variable %uv_name%:
echo.
set /p uv_val=. 
if [%uv_val%] == [] goto user_val_empty
setx %uv_name% %uv_val%
echo.
pause
goto start

:sys_var
cls
goto permissions_check_sys_var
:admin_success_sys_var
set sv_name=
set sv_val=
echo =========================================================================================
echo  Please Enter the name of the system variable:
echo.
set /p sv_name=. 
if [%sv_name%] == [] goto sys_name_empty
cls
:sys_var_val
cls
echo =========================================================================================
echo  Now enter the value of system variable %sv_name%:
echo.
set /p sv_val=. 
if [%sv_val%] == [] goto sys_val_empty
setx /m %sv_name% %sv_val%
echo.
pause
goto start

:user_path_var
cls
set upv_val=
set key="HKCU\Environment"
for /f "usebackq tokens=2*" %%A in (`reg query %key% /v path`) do set curr_path=%%B
echo %curr_path% > user_path_bak.txt
echo =========================================================================================
echo  Please Enter the path you want to append to the user PATH variable:
echo.
set /p upv_val=. 
if [%upv_val%] == [] goto user_path_var_empty
setlocal enableDelayedExpansion
:count_user_path_var
if "!curr_path:~%len%!" neq "" set /a len+=1 & goto count_user_path_var
if %len% GTR 1024 goto would_truncate_user_path_var
if "%curr_path:~-1%" neq ";" (
setx path "%curr_path%";%upv_val%;
) else (
setx path "%curr_path%"%upv_val%;
)
echo.
pause
goto start

:sys_path_var
cls
goto permissions_check_sys_path_var
:admin_success_sys_path_var
set spv_val=
set key="HKLM\SYSTEM\CurrentControlSet\Control\Session Manager\Environment"
for /f "usebackq tokens=2*" %%A in (`reg query %key% /v path`) do set curr_path=%%B
echo %curr_path% > %~dp0\sys_path_bak.txt
echo =========================================================================================
echo  Please Enter the path you want to append to the system PATH variable:
echo.
set /p spv_val=. 
if [%spv_val%] == [] goto sys_path_var_empty
setlocal enableDelayedExpansion
:count_sys_path_var
if "!curr_path:~%len%!" neq "" set /a len+=1 & goto count_sys_path_var
if %len% GTR 1024 goto would_truncate_sys_path_var
if "%curr_path:~-1%" neq ";" (
setx path "%curr_path%";%spv_val%; /m
) else (
setx path "%curr_path%"%spv_val%; /m
)
echo.
pause
goto start

:show_user_path_var
cls
set key="HKCU\Environment"
for /f "usebackq tokens=2*" %%A in (`reg query %key% /v path`) do set curr_path=%%B
echo =========================================================================================
echo  User Path Variable:
echo.
echo %curr_path%
echo.
pause
goto start

:show_sys_path_var
cls
set key="HKLM\SYSTEM\CurrentControlSet\Control\Session Manager\Environment"
for /f "usebackq tokens=2*" %%A in (`reg query %key% /v path`) do set curr_path=%%B
echo =========================================================================================
echo  System Path Variable:
echo.
echo %curr_path%
echo.
pause
goto start

:would_truncate_user_path_var
echo 
cls
echo =========================================================================================
echo  The user PATH variable is currently greater than 1024. This function is built on the
echo  command setx. Unfortunately, it was not designed to change path variables with more
echo  than 1024 characters. It would truncate the variable to this number of characters. For
echo  this reason, I provide the same script, based on the command "pathman", which is
echo  normally part of the Windows Resource Kit.
echo.
echo  If i wouldn`t do the exception handling, the script normally would issue the following:
echo.
echo  "WARNING: The data being saved is truncated to 1024 characters.
echo.
echo  SUCCESS: Specified value was saved."
echo.
echo  For the sake of completeness:
echo.
echo  The user PATH variable has not been changed. Please use the other script!
echo.
pause
goto start

:would_truncate_sys_path_var
echo 
cls
echo =========================================================================================
echo  The system PATH variable is currently greater than 1024. This function is built on the
echo  command setx. Unfortunately, it was not designed to change path variables with more
echo  than 1024 characters. It would truncate the variable to this number of characters. For
echo  this reason, I provide the same script, based on the command "pathman", which is
echo  normally part of the Windows Resource Kit.
echo.
echo  If i wouldn`t do the exception handling, the script normally would issue the following:
echo.
echo  "WARNING: The data being saved is truncated to 1024 characters.
echo.
echo  SUCCESS: Specified value was saved."
echo.
echo  For the sake of completeness:
echo.
echo  The system PATH variable has not been changed. Please use the other script!
echo.
pause
goto start

:user_name_empty
echo 
cls
echo =========================================================================================
echo  Input can not be empty!
echo.
pause
goto user_var

:sys_name_empty
echo 
cls
echo =========================================================================================
echo  Input can not be empty!
echo.
pause
goto sys_var

:user_val_empty
echo 
cls
echo =========================================================================================
echo  Input can not be empty!
echo.
pause
goto user_var_val

:sys_val_empty
echo 
cls
echo =========================================================================================
echo  Input can not be empty!
echo.
pause
goto sys_var_val

:user_path_var_empty
echo 
cls
echo =========================================================================================
echo  Input can not be empty!
echo.
pause
goto user_path_var

:sys_path_var_empty
echo 
cls
echo =========================================================================================
echo  Input can not be empty!
echo.
pause
goto sys_path_var

:permissions_check_sys_var
net session >nul 2>&1
if %errorLevel% == 0 (
goto admin_success_sys_var
) else (
echo 
cls
echo =========================================================================================
echo Failure: Current permissions inadequate. Restart batch with administrative permissions!
echo.
pause
goto start
)
pause >nul

:permissions_check_sys_path_var
net session >nul 2>&1
if %errorLevel% == 0 (
goto admin_success_sys_path_var
) else (
echo 
cls
echo =========================================================================================
echo Failure: Current permissions inadequate. Restart batch with administrative permissions!
echo.
pause
goto start
)
pause >nul